#!/bin/bash
#set -x
set -e

echoPrefix="\033[36m+"
echoSuffix="\033[0m"

codePath=/home/admin/.jenkins/workspace/wms-ui-mobile-prod

deploy() {
  # 更新代码
  echo -e "$echoPrefix cd $codePath/wms-ui-mobile $echoSuffix"
  cd $codePath/wms-ui-mobile
  # 版本号
  major='1'
  minor=$(date +%Y%m%d)
  patch=$(date +1%H%M%S | sed -e 's/^[[:space:]]*//')
  version="$major.$minor.$patch"
  echo -e "$echoPrefix 'export const version = '$version'' > src/version.ts $echoSuffix"
  echo "export const version = '$version'" > src/version.ts

  echo "###--代码更新完成--------------------------------------------------------------------------###"
  echo ""

  # 编译
  echo -e "$echoPrefix yarn run build $echoSuffix"
  yarn run init
  yarn run build
  echo "###--编译完成-----------------------------------------------------------------------------###"
  echo ""

  # 创建打包文件夹
  echo -e "$echoPrefix rm -rf ./tmp $echoSuffix"
  rm -rf ./tmp

  echo -e "$echoPrefix mkdir -p ./tmp/web/wms_mobile $echoSuffix"
  mkdir -p ./tmp/web/wms_mobile

  echo -e "$echoPrefix cp -r ./dist/* ./tmp/web/wms_mobile/ $echoSuffix"
  cp -r ./dist/* ./tmp/web/wms_mobile/

  echo -e "$echoPrefix cd ./tmp $echoSuffix"
  cd ./tmp
  echo -e "$echoPrefix zip -r web.zip web $echoSuffix"
  zip -r web.zip web
  echo '{"major":"'$major'","minor":"'$minor'","patch":"'$patch'"}' > version.json

  echo "###--打包完成-----------------------------------------------------------------------------###"
  echo ""

  # 还原文件
  # echo -e "$echoPrefix rm -rf ./tmp $echoSuffix"
  # rm -rf ./tmp
  echo -e "$echoPrefix cd $codePath $echoSuffix"
  cd $codePath
  echo -e "$echoPrefix git checkout . $echoSuffix"
  git checkout .
  echo -e "$echoPrefix 版本号信息: version=$version, major=$major, minor=$minor, patch=$patch $echoSuffix"
  echo ""
}

cmd=$1
if [ "$cmd" == "deploy" ];then
  deploy
else
  echo "使用 deploy 命名打包pda"
fi

# 中通服 PDA
# bash <(curl -s http://git.yvanui.com/lizhiwei/jztd-deploy/raw/master/02zhongtongfu/04wms-ztf-pad-prod.sh) [cmd]
